#pragma once

/* bitmask rule

   [28 - 31]					[0-27]
  |   HEADER |	    USER & SERVER INDEX FIELD	    |	
  |   0000   |   0000 0000 0000 0000 0000 0000 0000 |

  ACTOR_TYPE [31] bit field
  When SERVER , 1  
  When USER ,	0
  
  ACTION TYPE [30-28] bit field
  When Recv TCP Packet						,	 000
  When Recv UDP Paccket						,	 001
  When Disconnect Socket					,	 010
  When destroy worker thread				,	 011
   

*/

enum ACTOR_TYPE 
{
	ACTOR_TYPE_SERVER = 0x80000000,
	ACTOR_TYPE_USER	 = 0x00000000
};
enum ACTION_TYPE
{
	ACTION_TYPE_TCP				=	0x00000000,
	ACTION_TYPE_UDP				=	0x10000000,
	ACTION_TYPE_DISCONNECT		=	0x20000000,
	ACTION_TYPE_DESTROY			=	0x30000000,
};

enum NETWORK_ID 
{
	ID_NETWORK_FOR_USER		=	ACTOR_TYPE_USER,
	ID_NETWORK_FOR_SERVER	=	ACTOR_TYPE_SERVER,
	ID_NETWORK_FOR_UDP		=	ACTION_TYPE_UDP
};
#define	CONNECT_DISCONNECT_MASK		0x20000000
#define ACTION_TYPE_BIT_MASK		0x70000000
#define ACTOR_TYPE_BIT_MASK			0x80000000
#define HEADER_BIT_MASK				0xf0000000
#define CONNECTION_INDEX_BIT_MASK	0x0fffffff 

#define INVERSE_ACTION_TYPE_BIT_MASK	0x8fffffff
#define INVERSE_ACTOR_TYPE_BIT_MASK		0x7fffffff

enum CONNECTION_STATUS 
{
	CONNECTION_STATUS_DISCONNECTED	=	0,
	CONNECTION_STATUS_CONNECTED		= 1013
};

enum MAIN_THREAD_EVENT_INDEX
{
	EVENT_INDEX_MSG_EVENT			= 0,
	EVENT_INDEX_DESTROY				= 1,
	EVENT_INDEX_BREAK				= 2,
	EVENT_INDEX_RESUME				= 3,
	EVENT_INDEX_PRE_CONNECT			= 4,
	EVENT_INDEX_USER_DEFINE_0		= 5
};

#define MIM_MAIN_THREAD_EVENT_NUM  5
#define MAX_MAIN_THREAD_EVENT_NUM  64
#define	MAX_MAIN_THREAD_USER_DEFINE_EVENT_NUM 59
#define MAX_WORKER_THREAD_NUM 64
#define MAX_WSABUF_NUM_IN_SEND_FUNC 1200
#define MAX_TIMER_NUM	32


#define	NETDDSC_ENCRYPTION			0x00000001
#define NETDDSC_ENCRYPTION_MASK		0x0000000f
#define NETDDSC_DEBUG_LOG			0x00000010
#define	NETDDSC_DEBUG_LOG_MASK		0x000000f0


